#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=ssd_logo.ico
#AutoIt3Wrapper_Outfile=SSD.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment= SSD - SetSoundDevice on Win7, 2010-2013 by Karsten Funk. All rights reserved. http://www.funk.eu
#AutoIt3Wrapper_Res_Description=SetSoundDevice on Win7
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright= Karsten Funk under Creative Commons "by-nc-sa 3.0"
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Res_Field=Made By|Karsten Funk
#AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
#AutoIt3Wrapper_Res_Field=Compile Date|%date% %time%
#AutoIt3Wrapper_Res_Field=ProductName|SMF - Search my Files
#AutoIt3Wrapper_Res_Field=ProductVersion|%AutoItVer%
#AutoIt3Wrapper_Res_Field=CompanyName|Karsten Funk. All rights reserved. http://www.funk.eu
#AutoIt3Wrapper_Res_Field=LegalTrademarks|by-nc-sa 3.0
#AutoIt3Wrapper_Res_Field=InternalName|%scriptfile%
#AutoIt3Wrapper_Res_Field=Platform|Vista/Win7/Win8
#AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
#AutoIt3Wrapper_Run_AU3Check=n
#AutoIt3Wrapper_Tidy_Stop_OnError=n
#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/sf /sv /om /cs=0 /cn=0
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

; #  PROGRAM HEADER  # ==========================================================================================================
;
; Name...........: SSD - SetSoundDevice on Win7
;
; Description ...: Windows XP allows you to output sound to more than one audio device. Win Vista and Windows 7 do not.
;                  To overcome this Failure by Design, (IMHO somehow related to DRM, preventing user to make digital
;                  copies of analog sources), Ive coded SSD  Set Sound Device.
;
; Author ........: Karsten Funk (KaFu)
;
; Buildnumber....: 1300, 2013 Oct 18
; AutoIt Version.: 3.3.8.1
;
; Website........: http://funk.eu/ssd/
;
; Comments.......: For the "invisible" mode SSD opens the Control Panel on a separate Desktop (see "CreateDesktop" call).
;
; ===============================================================================================================================

#region DllOpen_PostProcessor START
Global $h_DLL_Kernel32 = DllOpen("kernel32.dll")
Global $h_DLL_User32 = DllOpen("user32.dll")
OnAutoItExitRegister("_OnAutoitExit_CloseDlls")
#endregion DllOpen_PostProcessor START

#region ;----- Includes -----
#include <ComboConstants.au3>
#include <GUIConstantsEx.au3>
#include <Misc.au3>
#include <Winapi.au3>
#include <WindowsConstants.au3>
#include <_EnumChildWindows.au3>
#include <WinAPIEx_3.8_3380\APIConstants.au3>
#include <WinAPIEx_3.8_3380\WinAPIEx.au3>
#endregion ;----- Includes -----

Global $sGUITitle = "SSD - SetSoundDevice - v1.3"

If $__WINVER < 0x0600 Then ; Windows Vista or later
	MsgBox(16 + 262144, $sGUITitle & " - Info", "SSD works on Win7 (maybe Vista, but untested) only.")
	Exit
EndIf

Global $hWnd_Sound, $iPID_Sound, $timer_timeout, $iDeviceNo = 0

If @Compiled And $CmdLineRaw And StringInStr($CmdLineRaw, "hidden") Then
	;ConsoleWrite("$CmdLineRaw "  & $CmdLineRaw & @crlf)
	$iDeviceNo = Number(StringReplace($CmdLineRaw, "hidden", ""))
	$hPrev = _WinAPI_GetThreadDesktop(_WinAPI_GetCurrentThreadId())
	$hDesktop = _WinAPI_CreateDesktop('SSD_Desktop', BitOR($DESKTOP_CREATEWINDOW, $DESKTOP_SWITCHDESKTOP))
	If Not $hDesktop Then
		MsgBox(16 + 262144, $sGUITitle & 'Error', 'Unable to create desktop, SSD will not work hidden.')
		Exit
	EndIf
	;_WinAPI_SwitchDesktop($hDesktop)
	$tProcess = DllStructCreate($tagPROCESS_INFORMATION)
	$tStartup = DllStructCreate($tagSTARTUPINFO)
	DllStructSetData($tStartup, 'Size', DllStructGetSize($tStartup))
	Global $tDesktop
	DllStructSetData($tStartup, 'Desktop', _WinAPI_CreateString('SSD_Desktop', $tDesktop))
	If _WinAPI_CreateProcess('', '"' & @ScriptFullPath & '" ' & $iDeviceNo, 0, 0, 0, $CREATE_NEW_PROCESS_GROUP, 0, 0, DllStructGetPtr($tStartup), DllStructGetPtr($tProcess)) Then
		ProcessWaitClose(DllStructGetData($tProcess, 'ProcessID'),20)
		ProcessClose(DllStructGetData($tProcess, 'ProcessID'))
	EndIf
	;_WinAPI_SwitchDesktop($hPrev)
	_WinAPI_CloseDesktop($hDesktop)
	Exit
ElseIf @Compiled And $CmdLineRaw Then
	$iDeviceNo = Number($CmdLineRaw)
EndIf

$timer_timeout = TimerInit()
While ProcessExists("rundll32.exe")
	ProcessClose("rundll32.exe")
	If TimerDiff($timer_timeout) > 10000 Then _Exit_Error()
	Sleep(250)
WEnd

$iPID_Sound = Run("rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,0", @ScriptDir, @SW_HIDE)

$timer_timeout = TimerInit()
While Not IsHWnd($hWnd_Sound)
	$hWnd_Sound = _Detect_Sound_dialog_hWnd($iPID_Sound)
	If TimerDiff($timer_timeout) > 10000 Or Not ProcessExists($iPID_Sound) Then
		_Exit()
	EndIf
WEnd

$aEnumList = _EnumChildWindows($hWnd_Sound, 0, 0, "SysListView32")
If $aEnumList[0][0] = 1 Then
	If $iDeviceNo = 0 Then
		$iListviewSize = ControlListView($aEnumList[1][0], "", 0, "GetItemCount")
		If Not $iListviewSize > 0 Then
			MsgBox(16 + 262144, $sGUITitle & " - Error", "No rows found in SysListView32 control of the 'Sound' control panel dialog.")
			_Exit()
		EndIf
		Dim $aSoundDevices[$iListviewSize]
		For $i = 0 To $iListviewSize - 1
			For $y = 0 To 2
				$aSoundDevices[$i] &= ControlListView($aEnumList[1][0], "", 0, "GetText", $i, $y)
				If $y < 2 Then $aSoundDevices[$i] &= ", "
			Next
		Next

		GUICreate($sGUITitle, 400, 200)

		GUICtrlCreateIcon(@ScriptName, 0, 6, 4, 32, 32)
		GUICtrlCreateLabel("SSD - SetSoundDevice on Win7", 45, 9, 260, 20)
		GUICtrlSetFont(-1, 13, 800, 0, "Arial", 6)

		$c_label_Hyperlink_FunkEu = GUICtrlCreateLabel("http://www.funk.eu", 305, 9, 98, 17)
		GUICtrlSetColor($c_label_Hyperlink_FunkEu, 0xA7A6AA)
		GUICtrlSetFont($c_label_Hyperlink_FunkEu, 8, 400, 4, "Arial")
		GUICtrlSetColor($c_label_Hyperlink_FunkEu, 0x518CB8)
		GUICtrlSetCursor($c_label_Hyperlink_FunkEu, 0)

		GUICtrlCreateLabel("SSD enables you to change the default Sound Device for Vista && Win7 via the commandline. To call SSD from the commandline, the syntax is 'SSD.exe #' (where # is the number of the Sound Device to select from the list,'Select Default' dropdown box must be enabled to make device selectable)." & @CRLF & "Select Sound Device # to set as default:", 10, 10 + 40, 372, 70)
		GUICtrlSetFont(-1, 8.5, 400, 0, "Arial")
		$c_combo_devices = GUICtrlCreateCombo("", 10, 82 + 43, 380, 20, $CBS_DROPDOWNLIST)
		For $i = 0 To UBound($aSoundDevices) - 1
			GUICtrlSetData($c_combo_devices, $aSoundDevices[$i])
		Next
		For $i = 0 To UBound($aSoundDevices) - 1
			If StringInStr($aSoundDevices[$i], "Standard") Then GUICtrlSetData($c_combo_devices, $aSoundDevices[$i])
		Next

		$c_checkbox_create_shortcut = GUICtrlCreateCheckbox("Create shortcut in program directory", 10, 113 + 40, 190)
		GUICtrlSetFont(-1, 8.5, 400, 0, "Arial")
		GUICtrlSetState(-1, $GUI_CHECKED)

		$c_checkbox_create_shortcut_hidden = GUICtrlCreateCheckbox("Perform Sound Device Switch Hidden", 10, 113 + 40 + 20, 200)
		GUICtrlSetFont(-1, 8.5, 400, 0, "Arial")
		GUICtrlSetState(-1, $GUI_CHECKED)
		GUICtrlSetTip(-1, "The Sound Device Switch is performed by simulating" & @CRLF & "the clicks in the Sound Controlpanel. If you check" & @CRLF & "this box, the process will create a secondary hidden" & @CRLF & "desktop and perform the actual switch there.", " ", 1)

		$c_button_start = GUICtrlCreateButton("Change Default Sound Device", 212, 114 + 40, 180, 40)
		GUICtrlSetFont(-1, 8, 600, 0, "Arial")

		GUIRegisterMsg($WM_COMMAND, "My_WM_COMMAND")
		GUISetState(@SW_SHOW)

		While 1
			Switch GUIGetMsg()
				Case $GUI_EVENT_CLOSE
					GUIDelete()
					_Exit()
				Case $c_button_start
					ExitLoop
			EndSwitch
			If Not WinExists($hWnd_Sound) Then _Exit()
		WEnd
		For $i = 0 To UBound($aSoundDevices) - 1
			If GUICtrlRead($c_combo_devices) = $aSoundDevices[$i] Then
				$iDeviceNo = $i + 1
				If GUICtrlRead($c_checkbox_create_shortcut) = $GUI_CHECKED Then
					If GUICtrlRead($c_checkbox_create_shortcut_hidden) = $GUI_CHECKED Then
						FileCreateShortcut(@ScriptDir & "\" & @ScriptName, @ScriptDir & "\SSD - #" & $iDeviceNo & " " & StringLeft($aSoundDevices[$i], StringInStr($aSoundDevices[$i], ", ") - 1) & ".lnk", @ScriptDir, $iDeviceNo & "hidden", "SSD commandline shortcut", @ScriptDir & "\" & @ScriptName, "", "0", @SW_MINIMIZE)
					Else
						FileCreateShortcut(@ScriptDir & "\" & @ScriptName, @ScriptDir & "\SSD - #" & $iDeviceNo & " " & StringLeft($aSoundDevices[$i], StringInStr($aSoundDevices[$i], ", ") - 1) & ".lnk", @ScriptDir, $iDeviceNo, "SSD commandline shortcut", @ScriptDir & "\" & @ScriptName, "", "0", @SW_MINIMIZE)
					EndIf
				EndIf
			EndIf
		Next
		GUIDelete()
	EndIf
	If $iDeviceNo > 0 And WinExists($hWnd_Sound) Then
		ControlSend($hWnd_Sound, "", "", "{DOWN " & $iDeviceNo & "}")
		ControlClick($hWnd_Sound, "", "Button2")
		ControlClick($hWnd_Sound, "", "Button4")
	EndIf
Else
	MsgBox(16 + 262144, $sGUITitle & " - Error", "SysListView32 control in 'Sound' control panel dialog not found.")
EndIf

_Exit()

Func _Detect_Sound_dialog_hWnd($iPID)
	Local $hWnds = WinList("[CLASS:#32770;]", "")
	For $i = 1 To $hWnds[0][0]
		If BitAND(WinGetState($hWnds[$i][1], ''), 2) Then
			If WinGetProcess(_WinAPI_GetAncestor($hWnds[$i][1], $GA_ROOTOWNER)) = ProcessExists($iPID) Then
				Return $hWnds[$i][1]
			EndIf
		EndIf
	Next
	Return 0
EndFunc   ;==>_Detect_Sound_dialog_hWnd

Func _Exit()
	$timer_timeout = TimerInit()
	While ProcessExists($iPID_Sound)
		ProcessClose($iPID_Sound)
		If TimerDiff($timer_timeout) > 10000 Then
			_Exit_Error()
		EndIf
		Sleep(250)
	WEnd
	Exit
EndFunc   ;==>_Exit

Func _Exit_Error()
	If Not ProcessExists($iPID_Sound) Then
		If ProcessExists("rundll32.exe") Then $iPID_Sound = ProcessExists("rundll32.exe")
	EndIf
	If ProcessExists($iPID_Sound) Then MsgBox(16 + 262144, $sGUITitle & " - Error", "The process rundll32.exe with the PID " & $iPID_Sound & "could not be closed by SSD." & @CRLF & @CRLF & "SSD will exit now, close the process via Taskmanager.")
	Exit
EndFunc   ;==>_Exit_Error

Func _OnAutoitExit_CloseDlls()
	DllClose($h_DLL_Kernel32)
	DllClose($h_DLL_User32)
EndFunc   ;==>_OnAutoitExit_CloseDlls

Func MY_WM_COMMAND($hWnd, $Msg, $wParam, $lParam)
	Local $iIDFrom = BitAND($wParam, 0xFFFF) ;LoWord
	Local $iCode = BitShift($wParam, 16) ;HiWord

	Switch $iIDFrom

		Case $c_label_Hyperlink_FunkEu
			GUICtrlSetColor($c_label_Hyperlink_FunkEu, 0xFF0000)
			While _IsPressed("01", $h_DLL_User32)
				Sleep(10)
			WEnd
			GUICtrlSetColor($c_label_Hyperlink_FunkEu, 0x518CB8)
			ShellExecute('http://www.funk.eu/')
	EndSwitch
EndFunc   ;==>MY_WM_COMMAND